var isSelected = false;
var selectedRange = undefined;
var selectedText = undefined;
var resevedHTML = undefined;

function sendMethod(methodName, param) {
    window.location = "dbevent://"+ methodName + "&" + param;
}

function getRange(event) {
    var range;
    if (event.rangeParent && document.createRange) {
        range = document.createRange();
        range.setStart(event.rangeParent, event.rangeOffset);
        range.setEnd(event.rangeParent, event.rangeOffset);
        return range;
    } else if (document.caretRangeFromPoint) {
        range = document.caretRangeFromPoint(event.clientX, event.clientY);
        return range;
    } else if (document.caretPositionFromPoint) {
        range = document.caretPositionFromPoint(event.clientX, event.clientY);
        return range;
    }
    return undefined;
}

function redirectToWord(word, event, range) {
    var rect = range.getClientRects()[0];
    var url = "https://tapaction/?type=selectWord&word=" + word + "&clientX=" + event.clientX + "&clientY=" + event.clientY + "&rectLeft=" + rect.left + "&rectRight=" + rect.right + "&rectTop=" + rect.top + "&rectBottom=" + rect.bottom;

    if (word!=null && word.trim().length>0){
        var arr = new Array();
        arr.push("");
        arr.push(word);
        arr.push("");
        var jsonStr = JSON.stringify(arr);
        sendMethod("webview_onWLinkClicked",encodeURI(jsonStr));
    }
}


function isValidCharAtOffset(node, offset) {
    if (offset < node.length && offset >= 0) {
        let charRange = new Range();
        charRange.setStart(node, offset);
        charRange.setEnd(node, offset + 1);
        let charCode = charRange.toString().charCodeAt(0);
        if (!(charCode < 65 || (charCode > 90 && charCode < 97) || (charCode > 122 && charCode < 128))) {
            return true;
        }
    }
    return false;
}

function checkToClearSelection(event) {
    if (isSelected == true && selectedRange != undefined && resevedHTML != undefined) {
        isSelected = false;
        redirectToWord("", event, selectedRange);
        selectedRange.startContainer.parentElement.innerHTML = resevedHTML;
    }
}

function selectWord(event) {

    checkToClearSelection(event);

    var range = getRange(event);

    resevedHTML = range.startContainer.parentElement.innerHTML;

    var node = range.startContainer;

    let initialOffset = range.startOffset;
    let currentOffset = initialOffset;

    if (!isValidCharAtOffset(node, currentOffset)) {
        return;
    }
    while (isValidCharAtOffset(node, currentOffset)) {
        currentOffset--;
    }
    range.setStart(node, currentOffset + 1);
    currentOffset = initialOffset;
    while (isValidCharAtOffset(node, currentOffset)) {
        currentOffset++;
    }
    range.setEnd(node, currentOffset);

    if (selectedText == range.toString()) {
        selectedText = "";
        return;
    }

    redirectToWord(range.toString(), event, range);

    spanElem = document.createElement("span");
    spanElem.className = "textHighlight";
    spanElem.appendChild(range.extractContents());
    range.insertNode(spanElem);

    isSelected = true;
    selectedRange = range;
    selectedText = range.toString();

}

function switchToTapMode() {

    document.body.innerHTML = "<div id='mainContent'>" + document.body.innerHTML + "</div>";
    document.head.innerHTML += "<style> .textHighlight { background: #FFFF00; } #mainContent { -webkit-tap-highlight-color:transparent;}</style>";
    document.getElementById('mainContent').onclick = function (e) {
        selectWord(e);
    }

}
